package cn.iocoder.yudao.module.visit.service.info;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.visit.controller.admin.info.vo.*;
import cn.iocoder.yudao.module.visit.dal.dataobject.info.InfoDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 客户拜访记录 Service 接口
 *
 * @author 超级管理员
 */
public interface InfoService {

    /**
     * 创建客户拜访记录
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createInfo(@Valid InfoSaveReqVO createReqVO);

    /**
     * 更新客户拜访记录
     *
     * @param updateReqVO 更新信息
     */
    void updateInfo(@Valid InfoSaveReqVO updateReqVO);

    /**
     * 删除客户拜访记录
     *
     * @param id 编号
     */
    void deleteInfo(Long id);

    /**
     * 获得客户拜访记录
     *
     * @param id 编号
     * @return 客户拜访记录
     */
    InfoDO getInfo(Long id);

    /**
     * 获得客户拜访记录分页
     *
     * @param pageReqVO 分页查询
     * @return 客户拜访记录分页
     */
    PageResult<InfoDO> getInfoPage(InfoPageReqVO pageReqVO);
    /**
     * 获得客户拜访记录打印数据 根据ids
     *
     * @param ids 查询
     * @return 客户拜访记录
     */
    List<InfoPrintVO> getInfoByIds(List<Long> ids);
    /**
     * 获得客户拜访记录打印数据 根据客户名称
     *
     * @param companyName 查询
     * @return 客户拜访记录
     */
    InfoPrintVO getInfoByCompanyName(String companyName);

    List<InfoPrintVO> getUnionInfoByIds(List<Long> idList);

    void deleteInfoByIds(List<Long> idList);

    List<InfoPrintVO> getUnionAllInfoByIds(List<InfoDO> list);
}